var $body     = $(document.body),
    $search   = $('#search input'),
    $reset    = $('#search button[type="reset"]'),
    $content  = $('#contents'),
    $sections = $content.find('.topic'),
    $results  = $('#search-results'),
    $resultOL = $results.find('ol'),
    $sitenav  = $('#site-nav'),
    // navByCanon = navByCanon(),
    docSections = {};

// ************************************************************************

$content.on('scroll',syncTOC);
$search.on('change keydown keyup',showHideReset);
$reset.on('click',showHideReset);
$('#search').on('submit',false);
// Workaround bug http://stackoverflow.com/q/10918242/405017
$(window).hashchange(scrollIntoView);

syncTOC();

// $results.add($sitenav).on('click','a[href]',ajaxNavigateLink);
// History.Adapter.bind(window,'statechange',ajaxNavigateBack);

$sitenav.on('click','div.category',toggleNavHead);

if (/^http/i.test(location.protocol)){
	$body.addClass('online');
	$('#company').click(function(){
		location.href = 'http://developer.nvidia.com/'
	});
}

allow_nav_resizing();
just_enough_padding_after_content();

// ************************************************************************
// ************************************************************************
// ************************************************************************

function showHideReset(e){
	setTimeout(searchNow,1);
}

function searchNow(e){
	if (e && e.keyCode==27) $search.val('').blur(); // Esc
	var query = $search.val().replace(/^\s+|\s+$/g,'');
	clearSearchResults();
	if (query.length){
		showSearchResults();
		searchFor(query);
	}else{
		hideSearchResults();
	}
}

function searchFor(query){
	// Replace me
	var hits = [
		{ title:query
		, href:'visual-profiler.xhtml#properties-view'
		, text:'…this is what I found with your text in it…'
		, bold:'I found'
		},
		{ title:query
		, href:'visual-profiler.xhtml#console-view'
		, text:'…this is what I found with your text in it…'
		, bold:'I found'
		}
	];

	// If search results are fetched via an AJAX service, call addSearchResult during the callback
	for (var i=0,len=hits.length;i<len;++i) addSearchResult(hits[i]);
}


function showSearchResults(){
	$body.addClass('search-visible');
}
function hideSearchResults(){
	$body.removeClass('search-visible');
}
function clearSearchResults(){
	$resultOL.empty();
}

// values.href:  the address to link the title to
// values.title: the leading text to display (default:href)
// values.text:  summary of the hit to display below (optional)
// values.bold:  search term text to bold in the summary (optional)
function addSearchResult(values){
	if (!values.href) return;
	if (!values.title) values.title = values.href;
	var li = $('<li><h3><a href="'+values.href+'">'+values.title+'</a></h3></li>').appendTo($resultOL);
	if (values.text){
		var html = htmlEscape(values.text);
		if (values.bold){
			var re = new RegExp(RegExp.escape(values.bold),'gi');
			html = html.replace(re,'<strong>$&</strong>');
		}
		li.append('<p>'+html+'</p>');
	}
	return li;
}

// ************************************************************************

// Return an object mapping canonical names to the JS node in the $nav
// Also creates the necessary .$parent properties for bidi traversal
function navByCanon(){
	var map = {};
	process($nav);
	return map;

	function process(o){
		var k=o.$kids;
		map[canonical(o.href)]=o;
		if (k) for (var i=k.length;i--;){
			k[i].$parent=o;
			process(k[i]);
		}
	}
}

// ************************************************************************

function syncTOC(){
	var top = $content[0].scrollTop;
	var bestD = Number.NEGATIVE_INFINITY, best;
	$sections.each(function(){
		var d = this.offsetTop - top;
		if (d<=0 && d>bestD){
			bestD = d;
			best = this;
		}
	});
	if (!best) best = $sections.get(0);
	if (!best) return;
	var current = $('#site-nav .current');
	var href = current.find('a').attr('href');
	var wanted = '#'+best.id;
	if (href!=wanted){
		current.removeClass('current');
		$('#site-nav a[href="'+wanted+'"]').closest('li:visible').addClass('current');
	}
}

// ************************************************************************

function toggleNavHead(evt){
	if (evt.target.tagName.toLowerCase()=='a') return;
	var $this = $(this);
	var navheads = $sitenav.find('div.category').addClass('closed');
	navheads.next().addClass('closed');
	navheads.find('.twiddle').html('▷');
	$this.removeClass('closed').next().removeClass('closed');
	$this.find('.twiddle').html($this.hasClass('closed') ? '▷' : '▼');
}

// ************************************************************************

function allow_nav_resizing(){
	setNavWidth(readCookie('navwidth'));
	$('<div id="resize-nav"/>')
		.appendTo($sitenav)
		.mousedown(function(e){
			var originalX = e.screenX,
			    originalW = $sitenav.width(),
			    navWidth;
			$('*').attr('unselectable','on');
			$(document.body).addClass('drag-active').mousemove(function drag(e){
				navWidth = originalW + e.screenX - originalX;
				setNavWidth(navWidth);
			}).mouseup(function(){
				$(this).off('mousemove').off('mouseup').removeClass('drag-active');
				$('*').attr('unselectable','');
				setCookie('navwidth',navWidth);
			});
		});
	function setNavWidth(w){
		if (w){		
			$sitenav.width(w);
			$content.css({left:w+'px'});
		}
	}
}

// ************************************************************************

function just_enough_padding_after_content(){
	var $end  = $('#contents-end').css('margin',0),
	    $last = $('.topic:last');

	if ($('dl.landing-page').length) return; // No padding on landing pages

	$(window).on('resize',perfectPadding);
	perfectPadding();

	function perfectPadding(){
		// 15px is a hack to allow the header to overlap the top so that it can be highlighted in the sidebar
		$end.css('margin-top',Math.max($content[0].offsetHeight-$last.height()-15,0));
	}	
}

// ************************************************************************
function scrollIntoView(id){
	if ((typeof id==='string') || (id=location.hash.substr(1))){
		// Use this instead of el.scrollIntoView() to prevent horizontal scrolling
		var scrollPosition = $sections.find('.topic[id="'+id+'"]').offsetRelativeTo($content);
		if (scrollPosition) $content.scrollTop(scrollPosition.top);
	}
	else $content.scrollTop(0);
}

// function ajaxNavigateLink(evt){
// 	var url = evt.target.href; //getAttribute('href');
// 	if (canonical(url)==canonical(location.pathname)) return;
// 	if (ajaxNavigateTo(url)) evt.preventDefault();
// }

// function ajaxNavigateTo(url){
// 	var success = false;
// 	$.ajax(url,{
// 		async:false,
// 		dataType:'xml',
// 		success:function(xml){
// 			var $xml = $(xml);
// 			$content.empty();
// 			$xml.find('#contents > *').each(function(){
// 				var imported = document.importNode(this,true);
// 				$content[0].appendChild(imported);
// 			});
// 			$content[0].scrollTop = 0;
// 			$sections = $content.find('.topic');
//
// 			var title = $xml.find('html > head > title')[0].childNodes[0].nodeValue;
// 			document.title = title;
//
// 			var hash = /#([^#\/]+)/.exec(url);
// 			if (hash) setTimeout(function(){
//        scrollIntoView(hash[1]);
// 			},1);
//
// 			loadTOC(url);
//
// 			History.pushState({},title,url);
// 			success = true;
// 		},
// 		error:function(xhr,textStatus,errorThrown){
// 			console.log(textStatus,errorThrown);
// 		}
// 	});
// 	return success;
// }

// function ajaxNavigateBack(evt){
//   var state = History.getState(); // Note: We are using History.getState() instead of event.state
// 	ajaxNavigateTo(state.url);
// }

// ************************************************************************

// Prefix with backslash all characters with special meaning in regex; used with new RegExp
RegExp.escape = function(text) {
	return text.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
}

function htmlEscape(str){
	return str.replace(/&/g,'&amp;').replace(/</g,'&lt;').replace(/>/g,'&gt;');
}

// Given an arbitrary URL (which may include a #hash at the end)
// return the unique file address referenced in navigation.xml
function canonical(url){
	// Return just the unique filename.
	var canon = /([^\/#]+)(?:#[^#\/]*)?$/.exec(url);
	canon = canon && canon[1];
	return canon;
}

function atRoot(){
	return canonical(location.href)=='docs.html';
}

function relative(url){
	return atRoot() ? url : "../../"+url;
}

jQuery.fn.offsetRelativeTo = function(el){
	var $el=$(el), o=this.offset(), o2=$el.offset();
	if (o){
		o.top  -= o2.top  - $el.scrollTop();
		o.left -= o2.left - $el.scrollLeft();
	}
	return o;
}

function setCookie(name,value){
	document.cookie = name+'='+value+'; path=/';
}

function readCookie(name){
	for (var cs=document.cookie.split(/;\s*/),i=cs.length;i--;){
		var parts = cs[i].split('=');
		if (parts[0]==name) return parts[1];
	}
}
